import sys
import platform
import random
from datetime import datetime

# AsterBeltCreator
# by JackDole
# 2016.03.18 13:14:35
# converted to Python and enhanced by FaceDeer
# more enhanced by JD
# this version works with Python  2.7 and 3.4

#-------------------------------------------------------------------------------

Version = 'Python ' + (platform.python_version())
print (Version + '\n')

daysYear = 365.24218985
AU = 149597870.691
#eMass = 5.9736e24

#uncomment this line if you want repeatable results
#random.seed(100)

ObjectType = 'Asteroid'
RefPlane = 'Ecliptic'
epoch = 2457395.5


# Select preset
ts = "Preset - ( 1 = Vulcanoiden - 2 = Oort cloud - 3 = Toliman A comets - 0 = No preset : "
if sys.version_info >= (3,0):
    Preset = input(ts)
else:
    Preset = raw_input(ts)

if Preset == 'x' or Preset == 'q':
    exit()
if Preset == '':
    Preset = 0
Preset = int(Preset)
if Preset > 3:
    Preset = 0


# Preset Vulcanoids
if Preset == 1:
    NumberOfAster = 200
    AsterName = 'VS'
    RingCenter = 'Sol'
    InnerRadius = 0.15
    OuterRadius = 0.18
    MaxRadiusOfAster = 3
    MinRadiusOfAster = 0.1
    MaxEccentricity = 0.001
    MinEccentricity = 0.0
    MaxInclination = 10
    FileName = 'Vulcanoids'
    
# Preset Oort cloud
if Preset == 2:
    NumberOfAster = 2000
    AsterName = 'OS'
    RingCenter = 'Sol'
    InnerRadius = 5000
    OuterRadius = 50000
    MaxRadiusOfAster = 500
    MinRadiusOfAster = 0.1
    MaxEccentricity = 0.3
    MinEccentricity = 0.0
    MaxInclination = 180
    FileName = 'OortCloud'

# Preset Toliman A comets
if Preset == 3:
    ObjectType = 'Comet'
    NumberOfAster = 500
    AsterName = 'TC'
    RingCenter = 'Toliman A'
    InnerRadius = 0.15
    OuterRadius = 5
    MaxRadiusOfAster = 25
    MinRadiusOfAster = 0.1
    MaxEccentricity = 0.5
    MinEccentricity = 0.0
    MaxInclination = 180
    FileName = 'TolimanComets'


# No preset
if Preset == 0:
    if sys.version_info >= (3,0):
        # ObjectType = Asteroid or Comet
        AskObjectType = input("Type of object ( 1 = Asteroid - 2 = Comet ) - Default = 1 : ")
        if AskObjectType == '2':
            ObjectType = 'Comet'
        else:
            ObjectType =  'Asteroid'
        print (ObjectType)
        
        # Amount of asteroids
        NumberOfAster = input("Number of asteroids - Default = 200 : ")
        if NumberOfAster == '':
            NumberOfAster = 200
        NumberOfAster = int(NumberOfAster)
        print (NumberOfAster)
        
        # Name of the asteroids - a serial number is appended
        AsterName = input("Aster name - Default = S : ")
        if AsterName == '':
            AsterName = 'S'
        print (AsterName)
        
        # Center object
        RingCenter = input("Ring center - Default = Sol : ")
        if RingCenter == '':
            RingCenter = 'Sol'
        print (RingCenter)
        
        # Orbital radii in AU
        InnerRadius = input("Inner Radius in AU - Default = 5.0 : ")
        if InnerRadius == '':
            InnerRadius = 5.0
        InnerRadius = float(InnerRadius)
        print (InnerRadius)
        
        OuterRadius = input("Outer radius in AU - Default = 6.0 : ")
        if OuterRadius == '':
            OuterRadius = 6.0
        OuterRadius = float(OuterRadius)
        print (OuterRadius)
        
        MinRadiusOfAster = input("Min radius in km - Default = 0.1 : ")
        if MinRadiusOfAster == '':
            MinRadiusOfAster = 0.1
        MinRadiusOfAster = float(MinRadiusOfAster)
        print (MinRadiusOfAster)
        
        # Radius of asteroids in KM
        MaxRadiusOfAster = input("Max radius in km - Default = 50.0 : ")
        if MaxRadiusOfAster == '':
            MaxRadiusOfAster = 50.0
        MaxRadiusOfAster = float(MaxRadiusOfAster)
        print (MaxRadiusOfAster)
        
        #orbital eccentricity
        MaxEccentricity = input("Max eccentricity - Default = 0.1 : ")
        if MaxEccentricity == '':
            MaxEccentricity = 0.1
        MaxEccentricity = float(MaxEccentricity)
        print (MaxEccentricity)
        
        MinEccentricity = input("Min eccentricity - Default = 0.0 : ")
        if MinEccentricity == '':
            MinEccentricity = 0.1
        MinEccentricity = float(MinEccentricity)
        print (MinEccentricity)
        
        # Orbital inclination +- in degrees
        MaxInclination = input("Max inclination in degrees - Default = 10.0 : ")
        if MaxInclination == '':
            MaxInclination = 10.0
        MaxInclination = float(MaxInclination)
        print (MaxInclination)
        
        # Refplane
        RefPlane = input("RefPlane (Ecliptic, Equator, Extrasolar) - Default = Ecliptic : ")
        if RefPlane == '':
            RefPlane = 'Ecliptic'
        print (RefPlane)
        
        # Epoch
        epoch = input("Epoch - Default = 2457395.5 : ")
        if epoch == '':
            epoch = 2457395.5
        epoch = float(epoch)
        print (epoch)
        
        #FileName
        FileName = input("Output file name - Default = AsterRing : ")
        if FileName == '':
            FileName = 'Astering'
    else:
        # ObjectType = Asteroid or Comet
        AskObjectType = raw_input("Type of object ( 1 = Asteroid - 2 = Comet ) - Default = 1 : ")
        if AskObjectType == '2':
            ObjectType = 'Comet'
        else:
            ObjectType =  'Asteroid'
        print (ObjectType)
        
        # Amount of asteroids
        NumberOfAster = raw_input("Number of asteroids - Default = 200 : ")
        if NumberOfAster == '':
            NumberOfAster = 200
        NumberOfAster = int(NumberOfAster)
        print (NumberOfAster)
        
        # Name of the asteroids - a serial number is appended
        AsterName = raw_input("Aster name - Default = S : ")
        if AsterName == '':
            AsterName = 'S'
        print (AsterName)
        
        # Center object
        RingCenter = raw_input("Ring center - Default = Sol : ")
        if RingCenter == '':
            RingCenter = 'Sol'
        print (RingCenter)
        
        # Orbital radii in AU
        InnerRadius = raw_input("Inner Radius in AU - Default = 5.0 : ")
        if InnerRadius == '':
            InnerRadius = 5.0
        InnerRadius = float(InnerRadius)
        print (InnerRadius)
        
        OuterRadius = raw_input("Outer radius in AU - Default = 6.0 : ")
        if OuterRadius == '':
            OuterRadius = 6.0
        OuterRadius = float(OuterRadius)
        print (OuterRadius)
        
        MinRadiusOfAster = raw_input("Min radius in km - Default = 0.1 : ")
        if MinRadiusOfAster == '':
            MinRadiusOfAster = 0.1
        MinRadiusOfAster = float(MinRadiusOfAster)
        print (MinRadiusOfAster)
        
        # Radius of asteroids in KM
        MaxRadiusOfAster = raw_input("Max radius in km - Default = 50.0 : ")
        if MaxRadiusOfAster == '':
            MaxRadiusOfAster = 50.0
        MaxRadiusOfAster = float(MaxRadiusOfAster)
        print (MaxRadiusOfAster)
        
        #orbital eccentricity
        MaxEccentricity = raw_input("Max eccentricity - Default = 0.1 : ")
        if MaxEccentricity == '':
            MaxEccentricity = 0.1
        MaxEccentricity = float(MaxEccentricity)
        print (MaxEccentricity)
        
        MinEccentricity = raw_input("Min eccentricity - Default = 0.0 : ")
        if MinEccentricity == '':
            MinEccentricity = 0.1
        MinEccentricity = float(MinEccentricity)
        print (MinEccentricity)
        
        # Orbital inclination +- in degrees
        MaxInclination = raw_input("Max inclination in degrees - Default = 10.0 : ")
        if MaxInclination == '':
            MaxInclination = 10.0
        MaxInclination = float(MaxInclination)
        print (MaxInclination)
        
        # Refplane
        RefPlane = raw_input("RefPlane (Ecliptic, Equator, Extrasolar) - Default = Ecliptic : ")
        if RefPlane == '':
            RefPlane = 'Ecliptic'
        print (RefPlane)
        
        # Epoch
        epoch = raw_input("Epoch - Default = 2457395.5 : ")
        if epoch == '':
            epoch = 2457395.5
        epoch = float(epoch)
        print (epoch)
        
        #FileName
        FileName = raw_input("Output file name - Default = AsterRing : ")
        if FileName == '':
            FileName = 'Astering'
    


FileName =  '{0}_{1}.sc'.format(FileName, NumberOfAster)
print (FileName)

#-------------------------------------------------------------------------------

#rotation periods in hours. See https://www.boulder.swri.edu/~bottke/rubble/node3.html
MaxRotationPeriod = 12
MinRotationPeriod = 0.1

ChanceOfMoon = 0.75
ChanceOfBinary = 0.2

if ObjectType == 'Comet':
    ChanceOfMoon = 1.0
    ChanceOfBinary = 0.2


class Orbit:
    def PrintIt(self):
        result = ['\tOrbit\n\t{']
        if hasattr(self, 'epoch'):
            result.append('\t\tEpoch\t\t\t{0}'.format(self.epoch))
        else:
            result.append('\t\tEpoch\t\t\t2457395.5')
        if hasattr(self, 'semi'):
            result.append('\t\tSemiMajorAxis\t{0}'.format(self.semi))
        if hasattr(self, 'period'):
            result.append('\t\tPeriod\t\t\t{0}'.format(self.period))
        if hasattr(self, 'eccen'):
            result.append('\t\tEccentricity\t{0}'.format(self.eccen))
        if hasattr(self, 'incl'):
            result.append('\t\tInclination\t\t{0}'.format(self.incl))
        if hasattr(self, 'ascen'):
            result.append('\t\tAscendingNode\t{0}'.format(self.ascen))
        if hasattr(self, 'argof'):
            result.append('\t\tArgOfPericen\t{0}'.format(self.argof))
        if hasattr(self, 'refplane'):
            result.append('\t\tRefPlane\t\t"{0}"'.format(self.refplane))
        else:
            result.append('\t\tRefPlane\t\t"Ecliptic"')
        result.append('\t\tMeanAnomaly\t\t0.0')
        result.append('\t}')
        return '\n'.join(result)

class Asteroid:
    def PrintIt(self):
        result = [ObjectType + ' "{0}"\n{{\n\tParentBody\t"{1}"\n\tClass\t\t"Asteroid"'.format(self.name, self.parent)]
        if hasattr(self, 'radius'):
            result.append('\tRadius\t\t{0}\n'.format(self.radius))
        if hasattr(self, 'rotation'):
            result.append('\tRotationPeriod\t{0}'.format(self.rotation))
        if hasattr(self, 'obliquity'):
            result.append('\n\tObliquity\t\t{0}\n'.format(self.obliquity))
        result.append(self.orbit.PrintIt())
        result.append('}')
        return '\n'.join(result)

    def getSafeMoonRadius(self):
        return self.radius/AU * 1.2

class BinaryAsteroid:
    def PrintIt(self):
        result = ['Barycenter "{0}"\n{{\n\tParentBody\t"{1}"'.format(self.name, self.parent)]
        result.append(orbit.PrintIt())
        result.append('}\n')

        asteroid = Asteroid()
        asteroid.name = self.name + " A"
        asteroid.parent = self.name
        asteroid.radius = self.radius1
        asteroid.orbit = self.componentorbit
        result.append(asteroid.PrintIt())

        asteroid.name = self.name + " B"
        asteroid.radius = self.radius2
        asteroid.orbit.argof = (asteroid.orbit.argof + 180) % 360
        result.append(asteroid.PrintIt())
        return '\n'.join(result)

#three different random number generators that give a floating point number between
#the two parameters but with different distributions

def uniform(a, b):
    return random.uniform(a, b)

# A normal distribution placing a and b at three standard deviations out from the mean
# clamping the result so that there are no outliers beyond the desired range
def gaussian(a, b):
    result = random.gauss((a+b)/2.0, (b-a)/6.0)
    return max(min(result, b), a)

randomGenerator = gaussian

def makeMoon(parentAsteroid, moonCount):
    innerLimit = parentAsteroid.radius/AU * 1.1
    outerLimit = innerLimit * 20

    moon = Asteroid()
    moon.radius = random.uniform(parentAsteroid.radius/20, parentAsteroid.radius/4)
    moon.name = parentAsteroid.name + '.{0}'.format(moonCount)
    moon.parent = parentAsteroid.name

    orbit = Orbit()
    orbit.parent = parentAsteroid.name
    orbit.refplane = 'Equator'
    orbit.semi = random.uniform(innerLimit, outerLimit)
    orbit.incl = randomGenerator(-90, 90)
    orbit.eccen = randomGenerator(0, 0.1)
    orbit.argof = random.uniform(0,360)
    orbit.ascen = random.uniform(0,360)

    moon.orbit = orbit

    return moon.PrintIt()


def makeAsteroid(count, orbit):
    asteroid = Asteroid()
    asteroid.name = AsterName + ' {0}'.format(count)
    asteroid.parent = RingCenter
    asteroid.radius = randomGenerator(MinRadiusOfAster, MaxRadiusOfAster)
    asteroid.rotation = randomGenerator(MinRotationPeriod,MaxRotationPeriod)
    asteroid.obliquity = random.uniform(0,360)
    asteroid.orbit = orbit

    output = [asteroid.PrintIt()]
    
    moonCount = 0
    while random.random() > ChanceOfMoon and moonCount < 10:
        moonCount = moonCount + 1
        output.append(makeMoon(asteroid, moonCount))
    
    return '\n'.join(output)

def makeBinaryAsteroid(count, orbit):
    binary = BinaryAsteroid()
    binary.name = AsterName + ' {0}'.format(count)
    binary.parent = RingCenter
    binary.radius1 = randomGenerator(MinRadiusOfAster, MaxRadiusOfAster)
    binary.radius2 = binary.radius1 * random.uniform(0.25,1)
    binary.orbit = orbit

    componentOrbit = Orbit()
    componentOrbit.period = random.uniform(0.1, 3) / daysYear
    componentOrbit.incl = random.uniform(0,360)
    componentOrbit.eccen = randomGenerator(0, 0.1)
    componentOrbit.argof = random.uniform(0,360)
    componentOrbit.ascen = random.uniform(0,360)
    componentOrbit.refplane = 'Equator'

    binary.componentorbit = componentOrbit

    return binary.PrintIt()


with open(FileName, 'w') as outputfile:
    outputfile.write('// ' + ObjectType + 's made with AsterBeltCreator and ' + Version + '\n// {0}'.format(datetime.today()))

    for count in range(NumberOfAster):
        orbit = Orbit()
        orbit.semi = randomGenerator(InnerRadius, OuterRadius)
        orbit.incl = randomGenerator(-MaxInclination, MaxInclination)
        orbit.eccen = randomGenerator(MinEccentricity, MaxEccentricity)
        orbit.argof = random.uniform(0,360)
        orbit.ascen = random.uniform(0,360)
        orbit.epoch = epoch
        orbit.refplane = RefPlane

        outputfile.write('\n\n')

        if random.random() > ChanceOfBinary:
            outputfile.write(makeAsteroid(count+1, orbit))
        else:
            outputfile.write(makeBinaryAsteroid(count+1, orbit))

